commit 84e2ff4c7fbb6566f0030c0ff43a02b966bf786a
Author: jklowden <jklowden>
Date:   Sun Jul 6 16:44:24 2008 +0000

    unit tests accept command-line options

diff --git a/ChangeLog b/ChangeLog
index 8b08bed..478b039 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,7 +1,13 @@
+Sun Jul  6 12:25:38 EDT 2008	JK Lowden <jklowden@freetds.org>
+	* src/ctlib/unittests/Makefile.am src/ctlib/unittests/common.c
+	* src/ctlib/unittests/common.h
+	- unit tests accept command-line options
+	* src/ctlib/unittests/datafmt.c added
+	
 Sat Jul  5 18:52:45 EDT 2008	JK Lowden <jklowden@freetds.org>
 	* include/cspublic.h src/ctlib/cs.c src/ctlib/ct.c
-	- src/ctlib/unittests/Makefile.am src/ctlib/unittests/common.c
-	- src/ctlib/unittests/datafmt.c
+	* src/ctlib/unittests/Makefile.am src/ctlib/unittests/common.c
+	* src/ctlib/unittests/datafmt.c
 	- cs_convert sets output resultlen even when dest is too small. 
 	* src/odbc/prepare_query.c src/odbc/unittests/blob1.c
 	- make it compile....
@@ -373,4 +379,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2539 2008/07/05 22:57:53 jklowden Exp $
+$Id: ChangeLog,v 1.2540 2008/07/06 16:44:24 jklowden Exp $
diff --git a/src/ctlib/unittests/Makefile.am b/src/ctlib/unittests/Makefile.am
index 795cccd..e7044c7 100644
--- a/src/ctlib/unittests/Makefile.am
+++ b/src/ctlib/unittests/Makefile.am
@@ -1,10 +1,11 @@
-# $Id: Makefile.am,v 1.25 2007/08/16 08:10:09 freddy77 Exp $
+# $Id: Makefile.am,v 1.26 2008/07/06 16:44:24 jklowden Exp $
 TESTS		=	t0001 t0002 t0003 t0004 t0005 t0006 t0007 t0008 t0009 \
 			connect_fail ct_options lang_ct_param array_bind cs_diag \
 			get_send_data rpc_ct_param rpc_ct_setparam ct_diagclient \
 			ct_diagserver ct_diagall cs_config cancel \
 			blk_in blk_out ct_cursor ct_cursors \
-			ct_dynamic blk_in2
+			ct_dynamic blk_in2 datafmt
+
 check_PROGRAMS	=	$(TESTS)
 
 t0001_SOURCES		= t0001.c common.c common.h
@@ -35,6 +36,7 @@ ct_cursor_SOURCES	= ct_cursor.c common.c common.h
 ct_cursors_SOURCES	= ct_cursors.c common.c common.h
 ct_dynamic_SOURCES	= ct_dynamic.c common.c common.h
 blk_in2_SOURCES		= blk_in2.c common.c common.h
+datafmt_SOURCES		= datafmt.c common.c common.h
 
 AM_CPPFLAGS	=	-I$(top_srcdir)/include
 if MINGW32
@@ -42,5 +44,6 @@ AM_LDFLAGS	=	-no-fast-install
 else
 AM_LDFLAGS	=	-no-install
 endif
-LIBS		=	../libct.la @NETWORK_LIBS@
+#IBS		=	../libct.la @NETWORK_LIBS@
+LIBS		=	../.libs/libct.a @NETWORK_LIBS@
 CLEANFILES	=	tdsdump.out
diff --git a/src/ctlib/unittests/common.c b/src/ctlib/unittests/common.c
index b992b75..993e2f4 100644
--- a/src/ctlib/unittests/common.c
+++ b/src/ctlib/unittests/common.c
@@ -12,11 +12,19 @@
 #include <string.h>
 #endif /* HAVE_STRING_H */
 
+#if HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+
+#ifndef DBNTWIN32
+#include "replacements.h"
+#endif
+
 #include <ctpublic.h>
 #include "common.h"
 #include "ctlib.h"
 
-static char software_version[] = "$Id: common.c,v 1.16 2007/12/26 18:45:17 freddy77 Exp $";
+static char software_version[] = "$Id: common.c,v 1.17 2008/07/06 16:44:24 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 char USER[512];
@@ -26,10 +34,19 @@ char DATABASE[512];
 
 COMMON_PWD common_pwd = {0};
 
+static char *DIRNAME = NULL;
+static const char *BASENAME = NULL;
+
+static const char *PWD = "../../../PWD";
+
+
 int cslibmsg_cb_invoked = 0;
 int clientmsg_cb_invoked = 0;
 int servermsg_cb_invoked = 0;
 
+static CS_RETCODE continue_logging_in(CS_CONTEXT ** ctx, CS_CONNECTION ** conn, CS_COMMAND ** cmd, int verbose);
+
+
 CS_RETCODE
 read_login_info(void)
 {
@@ -39,15 +56,15 @@ read_login_info(void)
 	
 	if (common_pwd.initialized) {
 		strcpy(USER, common_pwd.USER);
-		strcpy(SERVER, common_pwd.SERVER);
 		strcpy(PASSWORD, common_pwd.PASSWORD);
+		strcpy(SERVER, common_pwd.SERVER);
 		strcpy(DATABASE, common_pwd.DATABASE);
 		return CS_SUCCEED;
 	}
 
-	in = fopen("../../../PWD", "r");
+	in = fopen(PWD, "r");
 	if (!in) {
-		fprintf(stderr, "Can not open PWD file\n\n");
+		fprintf(stderr, "Can not open PWD file \"%s\"\n\n", PWD);
 		return CS_FAIL;
 	}
 
@@ -71,21 +88,107 @@ read_login_info(void)
 	return CS_SUCCEED;
 }
 
+static CS_RETCODE
+establish_login(int argc, char **argv)
+{
+	extern char *optarg;
+	extern int optind;
+	COMMON_PWD options = {0};
+#if !defined(__MINGW32__) && !defined(_MSC_VER)
+	int ch;
+#endif
+
+	BASENAME = tds_basename((char *)argv[0]);
+	DIRNAME = dirname((char *)argv[0]);
+	
+#if !defined(__MINGW32__) && !defined(_MSC_VER)
+	/* process command line options (handy for manual testing) */
+	while ((ch = getopt(argc, argv, "U:P:S:D:f:m:v")) != -1) {
+		switch (ch) {
+		case 'U':
+			strcpy(options.USER, optarg);
+			break;
+		case 'P':
+			strcpy(options.PASSWORD, optarg);
+			break;
+		case 'S':
+			strcpy(options.SERVER, optarg);
+			break;
+		case 'D':
+			strcpy(options.DATABASE, optarg);
+			break;
+		case 'f': /* override default PWD file */
+			PWD = strdup(optarg);
+			break;
+		case 'm':
+			common_pwd.maxlength = strtol(optarg, NULL, 10);
+		case 'v':
+			common_pwd.fverbose = 1;
+			break;
+		case '?':
+		default:
+			fprintf(stderr, "usage:  %s [-v] [-f PWD]\n"
+					"        [-U username] [-P password]\n"
+					"        [-S servername] [-D database]\n"
+					, BASENAME);
+			exit(1);
+		}
+	}
+#endif
+	read_login_info();
+	
+	/* override PWD file with command-line options */
+	
+	if (*options.USER)
+		strcpy(USER, options.USER);
+	if (*options.PASSWORD)
+		strcpy(PASSWORD, options.PASSWORD);
+	if (*options.SERVER)
+		strcpy(SERVER, options.SERVER);
+	if (*options.DATABASE)
+		strcpy(DATABASE, options.DATABASE);
+	
+	return (*USER && *PASSWORD && *SERVER && *DATABASE)? CS_SUCCEED : CS_FAIL;
+}
+
+extern const char STD_DATETIME_FMT[];
+
+CS_RETCODE
+try_ctlogin_with_options(int argc, char **argv, CS_CONTEXT ** ctx, CS_CONNECTION ** conn, CS_COMMAND ** cmd, int verbose)
+{
+	CS_RETCODE ret;
+
+	if ((ret = establish_login(argc, argv)) != CS_SUCCEED) {
+		if (verbose) {
+			fprintf(stderr, "read_login_info() failed!\n");
+		}
+		return ret;
+	}
+	return continue_logging_in(ctx, conn, cmd, verbose);
+}
+
+/* old way: because I'm too lazy to change every unit test */
 CS_RETCODE
 try_ctlogin(CS_CONTEXT ** ctx, CS_CONNECTION ** conn, CS_COMMAND ** cmd, int verbose)
 {
-CS_RETCODE ret;
-char query[30];
-TDSCONTEXT *tds_ctx;
+	CS_RETCODE ret;
 
-	/* read login information from PWD file */
-	ret = read_login_info();
-	if (ret != CS_SUCCEED) {
+	if ((ret = read_login_info()) != CS_SUCCEED) {
 		if (verbose) {
 			fprintf(stderr, "read_login_info() failed!\n");
 		}
 		return ret;
 	}
+	return continue_logging_in(ctx, conn, cmd, verbose);
+}
+
+CS_RETCODE
+continue_logging_in(CS_CONTEXT ** ctx, CS_CONNECTION ** conn, CS_COMMAND ** cmd, int verbose)
+{
+	CS_RETCODE ret;
+	char query[30];
+	TDSCONTEXT *tds_ctx;
+
 	ret = cs_ctx_alloc(CS_VERSION_100, ctx);
 	if (ret != CS_SUCCEED) {
 		if (verbose) {
@@ -108,6 +211,15 @@ TDSCONTEXT *tds_ctx;
 		}
 		return ret;
 	}
+	if ((ret = ct_callback(*ctx, NULL, CS_SET, CS_CLIENTMSG_CB, 
+			       (CS_VOID*) clientmsg_cb)) != CS_SUCCEED) {
+		fprintf(stderr, "ct_callback() failed\n");
+		return ret;
+	}
+	if ((ret = ct_callback(*ctx, NULL, CS_SET, CS_SERVERMSG_CB, servermsg_cb)) != CS_SUCCEED) {
+		fprintf(stderr, "ct_callback() failed\n");
+		return ret;
+	}
 	ret = ct_con_alloc(*ctx, conn);
 	if (ret != CS_SUCCEED) {
 		if (verbose) {
@@ -263,13 +375,18 @@ CS_RETCODE
 servermsg_cb(CS_CONTEXT * context, CS_CONNECTION * connection, CS_SERVERMSG * srvmsg)
 {
 	servermsg_cb_invoked++;
-	fprintf(stderr, "\nServer Message:\n");
-	fprintf(stderr, "number %d severity %d state %d line %d\n",
+
+	if (srvmsg->msgnumber == 5701 || srvmsg->msgnumber == 5703) {
+		fprintf(stderr, "%s\n", srvmsg->text);
+		return CS_SUCCEED;
+	}
+		
+	fprintf(stderr, "%s Message %d severity %d state %d line %d:\n",
+		srvmsg->svrnlen > 0? srvmsg->svrname : "Server", 
 		srvmsg->msgnumber, srvmsg->severity, srvmsg->state, srvmsg->line);
-	fprintf(stderr, "server: %s\n", (srvmsg->svrnlen > 0)
-		? srvmsg->svrname : "(null)");
-	fprintf(stderr, "proc: %s\n", (srvmsg->proclen > 0)
-		? srvmsg->proc : "(null)");
-	fprintf(stderr, "text: %s\n", srvmsg->text);
+	if (srvmsg->proclen > 0) 
+		fprintf(stderr, "proc %s: ", srvmsg->proc);
+	fprintf(stderr, "\t\"%s\"\n", srvmsg->text);
+
 	return CS_SUCCEED;
 }
diff --git a/src/ctlib/unittests/common.h b/src/ctlib/unittests/common.h
index 37a0185..1b0a52c 100644
--- a/src/ctlib/unittests/common.h
+++ b/src/ctlib/unittests/common.h
@@ -2,7 +2,7 @@
 #ifndef COMMON_h
 #define COMMON_h
 
-static char rcsid_common_h[] = "$Id: common.h,v 1.10 2004/07/21 19:28:01 freddy77 Exp $";
+static char rcsid_common_h[] = "$Id: common.h,v 1.11 2008/07/06 16:44:24 jklowden Exp $";
 static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_warn };
 
 extern char SERVER[512];
@@ -17,6 +17,8 @@ typedef struct
 	char DATABASE[512];
 	char USER[512];
 	char PASSWORD[512];
+	char fverbose;
+	int maxlength; 
 } COMMON_PWD;
 extern COMMON_PWD common_pwd;
 
@@ -27,7 +29,11 @@ extern int clientmsg_cb_invoked;
 extern int servermsg_cb_invoked;
 
 CS_RETCODE try_ctlogin(CS_CONTEXT ** ctx, CS_CONNECTION ** conn, CS_COMMAND ** cmd, int verbose);
+CS_RETCODE try_ctlogin_with_options(int argc, char **argv, CS_CONTEXT ** ctx, CS_CONNECTION ** conn, CS_COMMAND ** cmd, 
+				    int verbose);
+
 CS_RETCODE try_ctlogout(CS_CONTEXT * ctx, CS_CONNECTION * conn, CS_COMMAND * cmd, int verbose);
+
 CS_RETCODE run_command(CS_COMMAND * cmd, const char *sql);
 CS_RETCODE cslibmsg_cb(CS_CONTEXT * connection, CS_CLIENTMSG * errmsg);
 CS_RETCODE clientmsg_cb(CS_CONTEXT * context, CS_CONNECTION * connection, CS_CLIENTMSG * errmsg);

